import { Type } from "igniteui-react-core";
/**
 * Enumeration used to identify the cell to which the [[Spreadsheet]] should navigate when the enter key (or shift + enter) are pressed.
 */
export declare enum SpreadsheetEnterKeyNavigationDirection {
    /**
     * The cell below should be activated.
     */
    Down = 0,
    /**
     * The cell to the right should be activated
     */
    Right = 1,
    /**
     * The cell above should be activated.
     */
    Up = 2,
    /**
     * The cell to the left should be activated
     */
    Left = 3
}
/**
 * @hidden
 */
export declare let SpreadsheetEnterKeyNavigationDirection_$type: Type;
