import { IgrCancelEventArgs } from "igniteui-react-core";
import { SpreadsheetCommandExecutingEventArgs as SpreadsheetCommandExecutingEventArgs_internal } from "./SpreadsheetCommandExecutingEventArgs";
import { SpreadsheetAction } from "./SpreadsheetAction";
/**
 * Event arguments for the
 * actionExecuting event.
*/
export declare class IgrSpreadsheetActionExecutingEventArgs extends IgrCancelEventArgs {
    /**
                                 * @hidden
                                 */
    get i(): SpreadsheetCommandExecutingEventArgs_internal;
    constructor();
    /**
     * Returns the command which will be executed on the
     * Spreadsheet.
    */
    get command(): SpreadsheetAction;
    /**
     * Returns the parameter which will be used when executing the command.
    */
    get commandParameter(): any;
}
