import { SpreadsheetUserPromptDisplayingEventArgs as SpreadsheetUserPromptDisplayingEventArgs_internal } from "./SpreadsheetUserPromptDisplayingEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
import { SpreadsheetUserPromptTrigger } from "./SpreadsheetUserPromptTrigger";
/**
 * Event arguments for the
 * userPromptDisplaying event.
*/
export declare class IgrSpreadsheetUserPromptDisplayingEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): SpreadsheetUserPromptDisplayingEventArgs_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Returns a boolean indicating if the operation that triggered the prompt can be cancelled.
    */
    get canCancel(): boolean;
    /**
     * Returns or sets a boolean indicating whether the operation that triggered the prompt should be cancelled.
     * This property is only used if the
     * canCancel is true, which indicates that the
     * operation supports being cancelled, and if
     * displayMessage is set to false. Otherwise if the
     * message is shown and the operation may be cancelled then whether the operation is cancelled will be based
     * upon the users response to the prompt.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    /**
     * Returns or sets the caption for the message dialog that will be displayed.
    */
    get caption(): string;
    set caption(v: string);
    /**
     * Returns or sets a boolean indicating if a message will be displayed to the end user.
    */
    get displayMessage(): boolean;
    set displayMessage(v: boolean);
    /**
     * Returns the exception for the error, if there was one.
    */
    get exception(): any;
    /**
     * Returns or sets the message that will be displayed.
    */
    get message(): string;
    set message(v: string);
    /**
     * Returns an enumeration indicating the action caused the prompt to be displayed.
    */
    get trigger(): SpreadsheetUserPromptTrigger;
}
